#INCLUDE "Protheus.ch"
#INCLUDE "Topconn.ch"
#INCLUDE "Rwmake.ch"
#INCLUDE "MSOLE.CH"

/*


ͻ
Programa  ImpOrc    Autor  Paulo Costa          Data   12/07/12   
͹
Desc.      Impressao em Word de orcamento assistencia tecnica         
                                                                      
͹
Uso        Narita                                                     
ͼ


*/

User Function IMPORC()

Local oDlg    := NIL

//-----------------------
//Desenha a tela de impresso                       
//-----------------------

@ 096,042 TO 323,505 DIALOG oDlg TITLE "Impressao de Orcamento"
@ 008,010 TO 084,222
@ 018,020 SAY "Impressao do Oramento via Documento do WORD."
@ 030,020 SAY "Ser impresso de acordo com a selecao de parametros."
@ 095,130 BUTTON "Imprimir"  SIZE 45,10 ACTION Processa( {|| IMPORCII() }, "Processando..." )
@ 095,187 BMPBUTTON TYPE 2                      ACTION Close(oDlg)

ACTIVATE DIALOG oDlg CENTERED

Return Nil

/*


ͻ
Programa  ImpOrcII  Autor  Paulo Costa          Data   1207//12   
͹
Desc.      Imprime o oramento                                        
                                                                      
͹
Uso        Narita                                                     
ͼ


*/

Static Function IMPORCII()

Local _nVez    := 0 
Local _nTotal  := 0
Local _aCodpro := {}
Local _aDesc   := {}
Local _aItem   := {}
Local _aQtd    := {}
Local _aNCM    := {}
Local _aPreco  := {}
Local _aEntr   := {}  
Local _aICMs   := {}
Local _aIpi    := {}
Local cFileSave  := ''
Private cString  := ""
Private hWord
Private cPathDot :="\\192.168.0.9\Protheus10\dot\asstec.dot"  

AjustaSX1("IMPORC")
Pergunte("IMPORC", .T. )

//Ŀ
//Valida se o arquivo .dot est no local correto.
//

If !File(cPathDot)
	MsgBox ("Arquivo asstec.dot nao encontrado.","ERRO","STOP")
	Return(.F.)
Endif  

//Ŀ
//Posiciona as tabelas usadas na impresso do oramento
//

SCJ->( DbSetOrder(1) )
SA1->( DbSetOrder(1) )
SE4->( DbSetOrder(1) )
SCK->( DbSetOrder(1) )
SB1->( DbSetOrder(1) )

//Ŀ
//Valida a existncia do oramento.
//
    
    If! SCJ->( DbSeek(XFILIAL("SCJ")+mv_par01) )
    	apMsgStop('Orcamento no encontrado!')
		Return
	EndIf

//Ŀ
//Realiza pesquisa conforme paramtro.
//
		 		    
    SA1->( DbSeek(XFILIAL("SA1")+SCJ->CJ_CLIENTE+SCJ->CJ_LOJA) )
    SE4->( DbSeek(XFILIAL("SE4")+SCJ->CJ_CONDPAG) )
   	SCK->( DbSeek(XFILIAL("SCK")+mv_par01) )
    
	While !SCK->(Eof()) .and. SCK->CK_NUM = mv_par01
		If SB1->( DbSeek(XFILIAL("SB1")+SCK->CK_PRODUTO) )
			AADD(_aItem , SCK->CK_ITEM)
			AADD(_aCodPro , SCK->CK_PRODUTO)
			AADD(_aDesc , SB1->B1_DESC)
			AADD(_aQtd , SCK->CK_QTDVEN) 
			AADD(_aPreco , SCK->CK_PRCVEN)
			AADD(_aIpi , SB1->B1_IPI)
			AADD(_aICMS, SB1->B1_PICM)
			AADD(_aEntr ,SCK->CK_ENTREG)
			AADD(_aNCM  ,SB1->B1_POSIPI)
			_nTotal = _nTotal + SCK->CK_VALOR
		EndIf
		_nVez++			
		SCK->( dbSkip() )
	End   

    hWord    := OLE_CreateLink()
	OLE_NewFile(hWord, cPathDot ) // Abre o arquivo dot e comeca gravacao	  	
    	
    	OLE_SetDocumentVar(hWord, "_cjNum"    , SCJ->CJ_NUM)
 		OLE_SetDocumentVar(hWord, "_cjEmissao"   , SCJ->CJ_EMISSAO)
 		OLE_SetDocumentVar(hWord, "_cjVend"   , alltrim(SCJ->CJ_NVEND) )
 		OLE_SetDocumentVar(hWord, "_cjMaquina" , alltrim(SCJ->CJ_XEQPTO) )
 		OLE_SetDocumentVar(hWord, "_cjValidade"   , SCJ->CJ_VALIDA)   
    	OLE_SetDocumentVar(hWord, "_cjDepto"    ,    alltrim(SCJ->CJ_XDEPTO) )
 		OLE_SetDocumentVar(hWord, "_cjFone"     , SCJ->CJ_XDDD+'-'+SCJ->CJ_XFONE)
 		OLE_SetDocumentVar(hWord, "_cjEmail"      , SCJ->CJ_XEMAIL)
 		OLE_SetDocumentVar(hWord, "_cjObs"  , UPPER(SCJ->CJ_XOBS))
 		OLE_SetDocumentVar(hWord, "_cjFrete" , SCJ->CJ_TIPFRET) 
		OLE_SetDocumentVar(hWord, "_cjEmpresa"     , alltrim(SA1->A1_NOME) )
 		OLE_SetDocumentVar(hWord, "_cjCNPJ"    , transform(SA1->A1_CGC,"@R 99.999.999/9999-99") )    
		//OLE_SetDocumentVar(hWord, '_cjContato'    , TCQ->Contato)
		OLE_SetDocumentVar(hWord, "_cjPgto" , SE4->E4_DESCRI)
		OLE_SetDocumentVar(hWord, "_ckTotal", transform(_nTotal, "@E 99,999,999,999.99") )
		    		
	For i:=1 to _nVez 

//Ŀ
//variavel para identificar o numero total de linhas na parte variavel             
//Sera utilizado na macro do documento para execucao do for next					
//
		
		OLE_SetDocumentVar(hWord, "Prt_nroitens",_nVez)
				
//
//Montagem das variaveis dos itens. No documento word estas variaveis serao criadas 
//dinamicamente da seguinte forma:                                                  
//
		
 		OLE_SetDocumentVar(hWord, "_ckItem"+AllTrim(Str(i)) , _aItem[i] )
 		OLE_SetDocumentVar(hWord, "_ckProd"+AllTrim(Str(i)) , transform(_aCodPro[i], "@R XXX-XXX-XXX-XXX-XXX" ) )
 		OLE_SetDocumentVar(hWord, "_ckDesc"+AllTrim(Str(i)) , alltrim(_aDesc[i]) )
 		OLE_SetDocumentVar(hWord, "_ckQtde"+AllTrim(Str(i)) , alltrim(transform(_aQtd[i], "@E 99999999.99" ) ) )
 		OLE_SetDocumentVar(hWord, "_ckVal"+AllTrim(Str(i))  , alltrim(transform(_aPreco[i], "@E 99,999,999,999.99" ) ) )
		OLE_SetDocumentVar(hWord, "_ckEnt"+AllTrim(Str(i))  , _aEntr[i] )
		OLE_SetDocumentVar(hWord, "_ckIpi"+AllTrim(Str(i))  , _aIpi[i] )
 		OLE_SetDocumentVar(hWord, "_ckIcm"+AllTrim(Str(i))  , _aICMS[i] )
 		OLE_SetDocumentVar(hWord, "_ckNcm"+AllTrim(Str(i))  , _aNCM[i] )
        
        OLE_ExecuteMacro(hWord,"tabitens")
    Next
	              
	OLE_UpdateFields(hWord) //Atualiza os campos dentro do word
   	
//Ŀ
//Salva o documento			         
//

	cFileSave := "c:\orcamento\"
	OLE_SaveAsFile( hWord, cFileSave+"Proposta_"+SCJ->CJ_NUM+".doc" ) 
	MsgInfo("O documento foi salvo em C:\orcamento", "Ateno")
    
//Ŀ
//Fecha o Word e Corta o Link			 
//

 	OLE_CloseFile( hWord )
 	OLE_CloseLink( hWord )

Return nil

/*


ͻ
Programa  IMPORC    Autor  Microsiga            Data   07/13/12   
͹
Desc.                                                                 
                                                                      
͹
Uso        AP                                                        
ͼ


*/


Static Function AjustaSX1(cPerg)

Local aAreaAtu	:= GetArea()
Local aAreaSX1	:= SX1->( GetArea() )

PutSx1(	cPerg, "01", "Oramento de Venda ? ", "" , "","mv_ch1","C"                     ,TAMSX3("CJ_NUM")[1]  ,                       0 , 2,"G","",   "SCJ","","","mv_par01","","","","","","","","","","","","","","","","",{"Informe o numero do oramento para impressao",""},{""},{""},"")

RestArea( aAreaSX1 )
RestArea( aAreaAtu )

Return() 
   